package com.fr.nhbfunc;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.*;

import com.fr.base.FRContext;
import com.fr.base.Formula;
import com.fr.cache.Attachment;
import com.fr.data.ClassSubmitJob;
import com.fr.data.SubmitJob;
import com.fr.data.impl.SubmitJobValue;
import com.fr.general.FArray;
import com.fr.general.FRLogManager;
import com.fr.general.FRLogger;
import com.fr.script.Calculator;
import com.fr.stable.UtilEvalError;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;
import com.fr.script.AbstractFunction;
public class Defile implements SubmitJob{

	/**
	 * @param args
	 *  public Object run(Object[] args) {
        return null;
    }
	 */
	private String fpath;
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
	public void doJob(Calculator ca) throws Exception {
			new Thread() {
				public void run() {
					Defile hfc = new Defile();  
					String path;
				    path = fpath;  
				    boolean result = hfc.DeleteFolder(path);  
				    System.out.println(result+"--"+path+"!!"+fpath);  
				}
			}.start();
	}
	
//public static void main(String[] args) {  
//	Defile hfc = new Defile();  
//	String path;
//    path = "D:\\bb.txt";  
//    boolean result = hfc.DeleteFolder(path);  
//    System.out.println(result);  
//}  

	// 验证字符串是否为正确路径名的正则表达式  
	private static String matches = "[A-Za-z]:\\\\[^:?\"><*]*";  
	// 通过 sPath.matches(matches) 方法的返回值判断是否正确  
	// sPath 为路径字符串  

/** 
 *  根据路径删除指定的目录或文件，无论存在与否 
 *@param sPath  要删除的目录或文件 
 *@return 删除成功返回 true，否则返回 false。 
 */  
public boolean DeleteFolder(String sPath) {  
    boolean flag = false;  
    File file = new File(sPath);  
    // 判断目录或文件是否存在  
    if (!file.exists()) {  // 不存在返回 false  
        return flag;  
    } else {  
        // 判断是否为文件  
        if (file.isFile()) {  // 为文件时调用删除文件方法  
            return deleteFile(sPath);  
        } else {  // 为目录时调用删除目录方法  
            return deleteDirectory(sPath);  
        }  
    }  
}  

/** 
 * 删除单个文件 
 * @param   sPath    被删除文件的文件名 
 * @return 单个文件删除成功返回true，否则返回false 
 */  
public boolean deleteFile(String sPath) {  
    boolean flag = false;  
    File file = new File(sPath);  
    // 路径为文件且不为空则进行删除  
    if (file.isFile() && file.exists()) {  
        file.delete();  
        flag = true;  
    }  
    return flag;  
}  

/** 
 * 删除目录（文件夹）以及目录下的文件 
 * @param   sPath 被删除目录的文件路径 
 * @return  目录删除成功返回true，否则返回false 
 */  
public boolean deleteDirectory(String sPath) {  
    //如果sPath不以文件分隔符结尾，自动添加文件分隔符  
    if (!sPath.endsWith(File.separator)) {  
        sPath = sPath + File.separator;  
    }  
    File dirFile = new File(sPath);  
    //如果dir对应的文件不存在，或者不是一个目录，则退出  
    if (!dirFile.exists() || !dirFile.isDirectory()) {  
        return false;  
    }  
    boolean flag = true;  
    //删除文件夹下的所有文件(包括子目录)  
    File[] files = dirFile.listFiles();  
    for (int i = 0; i < files.length; i++) {  
        //删除子文件  
        if (files[i].isFile()) {  
            flag = deleteFile(files[i].getAbsolutePath());  
            if (!flag) break;  
        } //删除子目录  
        else {  
            flag = deleteDirectory(files[i].getAbsolutePath());  
            if (!flag) break;  
        }  
    }  
    if (!flag) return false;  
    //删除当前目录  
    if (dirFile.delete()) {  
        return true;  
    } else {  
        return false;  
    }  
}  
public String getJobType() {
	// TODO Auto-generated method stub
	return null;
}
public void readXML(XMLableReader reader) {
    // TODO Auto-generated method stub
}

public void writeXML(XMLPrintWriter writer) {
}

@Override
public void doFinish(Calculator arg0) throws Exception {
	// TODO Auto-generated method stub
	
}
}
